datablock ParticleData(CortezPoliceLightParticle)
{
	dragCoefficient = 0.0;
	gravityCoefficient = 0;
	inheritedVelFactor = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS = 1;
	lifetimeVarianceMS = 0;
	framesPerSec = 1;
	textureName = "base/lighting/corona";
	colors[0] = "1.000000 0.000000 0.000000 1.000000";
	colors[1] = "1.000000 0.000000 0.000000 1.000000";
	colors[2] = "1.000000 0.000000 0.000000 1.000000";
	colors[3] = "1.000000 0.000000 0.000000 1.000000";
	sizes[0] = "0.0";
	sizes[1] = "0.0";
	sizes[2] = "0.0";
	sizes[3] = "2.0";
	times[0] = "0.0";
	times[1] = "0.0";
	times[2] = "0.0";
	times[3] = "0.0";
};

datablock ParticleEmitterData(CortezPoliceLightEmitter)
{
	ejectionPeriodMS = 1;
	periodVarianceMS = 0;
	ejectionVelocity = 0;
	velocityVariance = 0.0;
	ejectionOffset = 0.0;
	thetaMin = 0;
	thetaMax = 180;
	phiReferenceVel = 0;
	phiVariance = 360;
	overrideAdvances = false;
	particles = "CortezPoliceLightParticle";
};

datablock ShapeBaseImageData(CortezPoliceLightAImage)
{
	shapeFile = "base/data/shapes/empty.dts";
	emap = false;

	mountPoint = 4;
	rotation = "0.0 0.0 0.0";
	offset = "0.0 0.0 0.0";

	stateName[0] = "Ready";
	stateEmitter[0] = CortezPoliceLightEmitter;
	stateEmitterTime[0] = 10000;
};

// Vehicle //
/////////////
datablock WheeledVehicleData(CortezVehicle)
{
	category = "Vehicles";
	displayName = " ";
	shapeFile = "./cortezbeta2.dts"; //"~/data/shapes/skivehicle.dts"; //
	emap = true;
	minMountDist = 3;
   
   numMountPoints = 4;
   mountThread[0] = "sit";
   mountThread[1] = "sit";
   mountThread[2] = "sit";
   mountThread[3] = "sit";

	maxDamage = 300.00;
	destroyedLevel = 300.00;
	energyPerDamagePoint = 160;
	speedDamageScale = 1.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier   = 0.02;

	massCenter = "0 0.48 0.1";
   //massBox = "2 5 1";

	maxSteeringAngle = 0.7854;  // Maximum steering angle, should match animation
	integration = 4;           // Force integration time: TickSec/Rate
	tireEmitter = VehicleTireEmitter; // All the tires use the same dust emitter

	// 3rd person camera settings
	cameraRoll = false;         // Roll the camera with the vehicle
	cameraMaxDist = 13;         // Far distance from vehicle
	cameraOffset = 7.5;        // Vertical offset from camera mount point
	cameraLag = 0.0;           // Velocity lag of camera
	cameraDecay = 0.75;        // Decay per sec. rate of velocity lag
	cameraTilt = 0.4;
   collisionTol = 0.1;        // Collision distance tolerance
   contactTol = 0.1;

	useEyePoint = false;	

	defaultTire	= CortezwheelTire;
	defaultSpring	= CortezSpring;
	//flatTire	= jeepFlatTire;
	//flatSpring	= jeepFlatSpring;

   numWheels = 4;

	// Rigid Body
	mass = 350;
	density = 5.0;
	drag = 1.6;
	bodyFriction = 0.6;
	bodyRestitution = 0.6;
	minImpactSpeed = 10;        // Impacts over this invoke the script callback
	softImpactSpeed = 10;       // Play SoftImpact Sound
	hardImpactSpeed = 15;      // Play HardImpact Sound
	groundImpactMinSpeed    = 10.0;

	// Engine
	engineTorque = 8000; //4000;       // Engine power
	engineBrake = 4000;         // Braking when throttle is 0
	brakeTorque = 50000;        // When brakes are applied
	maxWheelSpeed = 34;        // Engine scale by current speed / max speed

	rollForce		= 900;
	yawForce		= 600;
	pitchForce		= 1000;
	rotationalDrag		= 0.2;

   // Advanced Steering
   steeringAutoReturn = true;
   steeringAutoReturnRate = 0.9;
   steeringAutoReturnMaxSpeed = 10;
   steeringUseStrafeSteering = true;
   steeringStrafeSteeringRate = 0.1;

	// Energy
	maxEnergy = 100;
	jetForce = 3000;
	minJetEnergy = 30;
	jetEnergyDrain = 2;

	splash = vehicleSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	splashEmitter[0] = vehicleFoamDropletsEmitter;
	splashEmitter[1] = vehicleFoamEmitter;
	splashEmitter[2] = vehicleBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;   
	hardSplashSoundVelocity = 20.0;   
	exitSplashSoundVelocity = 5.0;
		
	//mediumSplashSound = "";
	//hardSplashSound = "";
	//exitSplashSound = "";
	
	// Sounds
	//   jetSound = ScoutThrustSound;
	//engineSound = idleSound;
	//squealSound = skidSound;
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
	//wheelImpactSound = slowImpactSound;

	//   explosion = VehicleExplosion;
	justcollided = 0;

   uiName = "Cortez ";
	rideable = true;
		lookUpLimit = 0.65;
		lookDownLimit = 0.45;

	paintable = true;
   
   damageEmitter[0] = VehicleBurnEmitter;
	damageEmitterOffset[0] = "0.0 0.0 0.0 ";
	damageLevelTolerance[0] = 0.99;

   damageEmitter[1] = VehicleBurnEmitter;
	damageEmitterOffset[1] = "0.0 0.0 0.0 ";
	damageLevelTolerance[1] = 1.0;

   numDmgEmitterAreas = 1;

   initialExplosionProjectile = CortezExplosionProjectile;
   initialExplosionOffset = 0;         //offset only uses a z value for now

   burnTime = 4000;

   finalExplosionProjectile = CortezFinalExplosionProjectile;
   finalExplosionOffset = 0.5;          //offset only uses a z value for now

   minRunOverSpeed    = 4;   //how fast you need to be going to run someone over (do damage)
   runOverDamageScale = 8;   //when you run over someone, speed * runoverdamagescale = damage amt
   runOverPushScale   = 1.2; //how hard a person you're running over gets pushed

   //protection for passengers
   protectPassengersBurn   = false;  //protect passengers from the burning effect of explosions?
   protectPassengersRadius = true;  //protect passengers from radius damage (explosions) ?
   protectPassengersDirect = false; //protect passengers from direct damage (bullets) ?
};

datablock WheeledVehicleData(Cortez4drVehicle : CortezVehicle)
{
	//- Vehicle Data -
	shapeFile = "./cortez4drbeta2.dts";
	uiName = "Cortez - 4 door";
	maxWheelSpeed = 33.0;
};

datablock WheeledVehicleData(CortezPoliceVehicle : Cortez4drVehicle)
{
	//- Vehicle Data -
	uiName = "Cortez - Police";
	maxWheelSpeed = 35.0;
	defaultTire	= CortezwheelpoliceTire;
};

function Cortez4drVehicle::onAdd(%db,%this)
{
	%this.hideNode(light);
	%this.hideNode(policeacc);
	
	parent::onAdd(%db,%this);
}

function CortezPoliceVehicle::onAdd(%db,%this)
{
	%this.unhideNode(light);
	%this.unhideNode(policeacc);
	
	if(!isObject(CortezPoliceSirenSO))
		new ScriptObject(CortezPoliceSirenSO);
	CortezPoliceSirenSO.addCar(%this);
	
	parent::onAdd(%db,%this);
}

function CortezPoliceSirenSO::addCar(%this,%obj)
{
	if(isObject(%obj))
		if(%obj.getDatablock() == CortezPoliceVehicle.getID())
			%this.car[%this.carCount++ - 1] = %obj;
	if(%this.carCount == 1)
		%this.loop();
}

function CortezPoliceSirenSO::removeCar(%this,%obj)
{
	for(%a = 0; %a < %this.carCount; %a++)
		if(%this.car[%a] == %obj)
			break;
	if(%a < %this.carCount)
		for(%b = %a; %b < %this.carCount; %b++)
			%this.car[%b] = %this.car[%b + 1];
}

function CortezPoliceSirenSO::loop(%this)
{
	cancel(%this.loop);
	
	if(%this.carCount > 0)
	{
		%this.state++;
		if(%this.state > 3)
			%this.state = 0;
		
		for(%a = 0; %a < %this.carCount; %a++)
		{
			if(!isObject(%this.car[%a]))
				%this.removeCar(%this.car[%a]);
			else
			{
				switch(%this.state)
				{
					case 0:
						%this.car[%a].unmountImage(1);
					case 1:
						if(%this.car[%a].useSiren)
							%this.car[%a].mountImage(CortezPoliceLightAImage,0);
					case 2:
						%this.car[%a].unmountImage(0);
					case 3:
						if(%this.car[%a].useSiren)
							%this.car[%a].mountImage(CortezPoliceLightAImage,0);
				}
			}
		}
		
		%this.loop = %this.schedule(250,loop);
	}
	else
		%this.schedule(0,delete);
}

package Vehicle_CortezPolice
{
	function serverCmdLight(%client)
	{
		if(isObject(%client.player) && !isObject(%client.player.light))
		{
			%player = %client.player;
			%veh = %player.getControlObject();
			if(isObject(%veh))
				if(%veh.getDatablock() == CortezPoliceVehicle.getID())
				{
					%veh.useSiren = !%veh.useSiren;
					return "";
				}
		}
		parent::serverCmdLight(%client);
	}
	function Vehicle::setNodeColor(%this,%node,%color)
	{
		parent::setNodeColor(%this,%node,%color);
		if(%this.getDatablock() == CortezPoliceVehicle.getID() && %node $= "ALL")
		{
			%r = getWord(%color,0);
			%g = getWord(%color,1);
			%b = getWord(%color,2);
			%lowest = 1;
			for(%a = 0; %a < 3; %a++)
			{
				%val = getWord(%color,%a);
				if(%val > %highest)
					%highest = %val;
				if(%val < %lowest)
					%lowest = %val;
			}
			%average = atof(%r) + atof(%g) + atof(%b);
			%average /= 3;
			%sat = %highest - %lowest;
			if(%sat < 0.1 && %average > 0.25)
				%sidePanel = "1.0 1.0 1.0 1.0";
			else
				%sidePanel = "1.0 1.0 1.0 1.0";
			%this.setNodeColor("white",%sidePanel);
			%this.setNodeColor("whitea",%sidePanel);
			%this.setNodeColor("whiteb",%sidePanel);
			%this.setNodeColor("whitec",%sidePanel);
		}
	}
};
activatePackage(Vehicle_CortezPolice);